A Walk Through the Forest(hdu1142,最短路+dfs)

http://acm.hdu.edu.cn/showproblem.php?pid=1142

A Walk Through the Forest

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)

Total Submission(s): 4623    Accepted Submission(s): 1676

Problem Description

Jimmy experiences a lot of stress at work these days, especially since his accident made working difficult. To relax after a hard day, he likes to walk home. To make things even nicer, his office is on one side of a forest, and his house is on the other. A nice walk through the forest, seeing the birds and chipmunks is quite enjoyable.

The forest is beautiful, and Jimmy wants to take a different route everyday. He also wants to get home before dark, so he always takes a path to make progress towards his house. He considers taking a path from A to B to be progress if there exists a route from B to his home that is shorter than any possible route from A. Calculate how many different routes through the forest Jimmy might take.

Input

Input contains several test cases followed by a line containing 0. Jimmy has numbered each intersection or joining of paths starting with 1. His office is numbered 1, and his house is numbered 2. The first line of each test case gives the number of intersections N, 1 < N ≤ 1000, and the number of paths M. The following M lines each contain a pair of intersections a b and an integer distance 1 ≤ d ≤ 1000000 indicating a path of length d between intersection a and a different intersection b. Jimmy may walk a path any direction he chooses. There is at most one path between any pair of intersections.

Output

For each test case, output a single integer indicating the number of different routes through the forest. You may assume that this number does not exceed 2147483647

Sample Input

5 6

1 3 2

1 4 2

3 4 3

1 5 12

4 2 34

5 2 24

7 8

1 3 1

1 4 1

3 7 1

7 4 1

7 5 1

6 7 1

5 2 1

6 2 1

0

Sample Output

2

4

Source

University of Waterloo Local Contest 2005.09.24

Recommend

Eddy

解析:

题意:

求:AB的路径有多少条,其中AB满足,A2的路径比B2的路径长。

思路:

1.由于是无向图,用Dijkstra求以2为起点的最短路径

2.dfs找出符合条件的路径条数

78MS 4196K 1267 B C++

*/


#include<stdio.h>
#include<string.h>
#include<stdlib.h>
#include<iostream>
using namespace std;
const int maxn=1000+10;
const int inf=1<<29;
int d[maxn],p[maxn],vis[maxn];
int n;
int w[maxn][maxn];
void init()
{
  for(int i=1;i<=n;i++)
   for(int j=1;j<=n;j++)
   {
   	if(i==j)
   	w[i][j]=0;
   	else
   	w[i][j]=inf;
   }
memset(p,-1,sizeof(p));
}
void Dijkstra(int s)
{
memset(vis,0,sizeof(vis));
for(int i=1;i<=n;i++)
d[i]=(i==s? 0:inf);
for(int i=1;i<=n;i++)
{
int x,t=inf;
for(int y=1;y<=n;y++)
if(!vis[y]&&d[y]<=t)//要在等级允许范围内进行
t=d[x=y];
vis[x]=1;
for(int y=1;y<=n;y++)//c[y]表示1到y点的最短路径
if(d[y]>d[x]+w[x][y])
d[y]=d[x]+w[x][y];
}
}
int dfs(int x)
{
if(p[x]!=-1)
return p[x];
p[x]=0;
for(int i=1;i<=n;i++)
if(w[i][x]!=inf&&d[x]>d[i])//路径存在且x到2的最短路大于i到2的最短路
p[x]+=dfs(i);
return p[x];
}
int main()
{
int i,j,m,ans;
while(scanf("%d",&n)!=EOF)
{
if(n==0)
break;
init();
scanf("%d",&m);
int u,v,c;
for(i=1;i<=m;i++)
{
scanf("%d%d%d",&u,&v,&c);
w[u][v]=w[v][u]=c;
//printf("%d %d\n",w[u][v],w[v][u]);
}
Dijkstra(2);
//for(i=1;i<=n;i++)
//printf("d[%d]==%d\n",i,d[i]);
p[2]=1;
dfs(1);
printf("%d\n",p[1]);
}
return 0;
}


  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值